use std::env;
use std::process;

fn main() {
    let args: Vec<String> = env::args().collect();
    let equation = computorv1::parse(&args[1]).unwrap_or_else(|e| {
        println!("Error during parsing: {e}");
        process::exit(1);
    });
    println!("{:?}", equation);
    let is_equation = computorv1::maths::evaluator::is_equation(&equation);
    let evaluated = computorv1::maths::evaluator::evaluate(equation);
    computorv1::pretty(&evaluated);
    if is_equation {
        computorv1::maths::solver::solve(evaluated);
    }
}
